"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _initializerDefineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/initializerDefineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _applyDecoratedDescriptor2 = _interopRequireDefault(require("@babel/runtime/helpers/applyDecoratedDescriptor"));

var _initializerWarningHelper2 = _interopRequireDefault(require("@babel/runtime/helpers/initializerWarningHelper"));

var _mobx = require("mobx");

var _mobxUtils = require("mobx-utils");

var _filters = require("../utils/filters.utils");

var _countries = _interopRequireDefault(require("./countries.store"));

var _dec, _dec2, _dec3, _dec4, _class, _descriptor, _temp;

var CountriesListPageStore = (_dec = _mobx.action.bound, _dec2 = _mobx.action.bound, _dec3 = _mobx.action.bound, _dec4 = _mobx.action.bound, (_class = (_temp =
/*#__PURE__*/
function () {
  function CountriesListPageStore() {
    var _this = this;

    var initialState = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _classCallCheck2["default"])(this, CountriesListPageStore);
    (0, _initializerDefineProperty2["default"])(this, "filtersState", _descriptor, this);
    this.isSelectedFilter = (0, _mobxUtils.computedFn)(function (filter) {
      return _this.filtersState[filter.groupId].includes(filter.value);
    });
    this.countriesStore = new _countries["default"](initialState.countries);
  }

  (0, _createClass2["default"])(CountriesListPageStore, [{
    key: "setFilter",

    /**
     * set filter
     * @param {{groupId, value}} filter
     */
    value: function setFilter(filter) {
      this.filtersState[filter.groupId].push(filter.value);
    }
    /**
     * reset filter
     * @param {{groupId, value}} filter
     */

  }, {
    key: "resetFilter",
    value: function resetFilter(filter) {
      this.filtersState[filter.groupId] = this.filtersState[filter.groupId].filter(function (value) {
        return value !== filter.value;
      });
    }
    /**
     * toggleFilter
     * @param {{groupId, value}} filter
     */

  }, {
    key: "toggleFilter",
    value: function toggleFilter(filter) {
      this.isSelectedFilter(filter) ? this.resetFilter(filter) : this.setFilter(filter);
    }
    /**
     * reset all filters
     */

  }, {
    key: "resetAllFilters",
    value: function resetAllFilters() {
      this.filtersState = (0, _filters.getInitialFilterState)();
    }
  }, {
    key: "countriesList",

    /**
     * countries list
     * @returns {Array<Object>}
     */
    get: function get() {
      return (0, _filters.filterCountries)({
        countries: this.countriesStore.countries,
        filtersState: this.filtersState
      });
    }
    /**
     * is selected filter
     * @param {{groupId, value}} filter
     * @return {Boolean}
     */

  }]);
  return CountriesListPageStore;
}(), _temp), (_descriptor = (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "filtersState", [_mobx.observable], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return (0, _filters.getInitialFilterState)();
  }
}), (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "countriesList", [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, "countriesList"), _class.prototype), (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "setFilter", [_dec], Object.getOwnPropertyDescriptor(_class.prototype, "setFilter"), _class.prototype), (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "resetFilter", [_dec2], Object.getOwnPropertyDescriptor(_class.prototype, "resetFilter"), _class.prototype), (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "toggleFilter", [_dec3], Object.getOwnPropertyDescriptor(_class.prototype, "toggleFilter"), _class.prototype), (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "resetAllFilters", [_dec4], Object.getOwnPropertyDescriptor(_class.prototype, "resetAllFilters"), _class.prototype)), _class));
exports["default"] = CountriesListPageStore;
