"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _initializerDefineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/initializerDefineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _applyDecoratedDescriptor2 = _interopRequireDefault(require("@babel/runtime/helpers/applyDecoratedDescriptor"));

var _initializerWarningHelper2 = _interopRequireDefault(require("@babel/runtime/helpers/initializerWarningHelper"));

var _mobx = require("mobx");

var _constants = require("../constants");

var _countries = require("../utils/countries.utils");

var _generateFilters = require("../utils/generate-filters.utils");

var _countries2 = _interopRequireDefault(require("../clients/countries.client"));

var _store = require("../utils/store.utils");

var _dec, _dec2, _class, _descriptor, _descriptor2, _descriptor3, _temp;

var CountriesStore = (_dec = _mobx.observable.shallow, _dec2 = _mobx.action.bound, (_class = (_temp =
/*#__PURE__*/
function () {
  /**
   * constructor
   * @param {Object} initialState
   */
  function CountriesStore() {
    var initialState = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _classCallCheck2["default"])(this, CountriesStore);
    (0, _initializerDefineProperty2["default"])(this, "data", _descriptor, this);
    (0, _initializerDefineProperty2["default"])(this, "API_STATE", _descriptor2, this);
    (0, _initializerDefineProperty2["default"])(this, "fetch", _descriptor3, this);
    this.updateInitialState(initialState);
  }

  (0, _createClass2["default"])(CountriesStore, [{
    key: "updateInitialState",

    /**
     * update initial state
     * @param {Object} initialState
     */
    value: function updateInitialState(initialState) {
      (0, _store.mapInitialStateToStoreState)(this, initialState);
    }
    /**
     * fetch all countries
     * @param {Function} errorHandler
     */

  }, {
    key: "onSuccess",

    /**
     * handle success
     * @param {Object} data
     */
    value: function onSuccess(data) {
      this.data = data;
      this.API_STATE = _constants.API_STATE.SUCCESS;
    }
    /**
     * handle error
     * @param {Object} error
     * @param {Function} errorHandler
     */

  }, {
    key: "onError",
    value: function onError(error, errorHandler) {
      errorHandler(error);
      this.API_STATE = _constants.API_STATE.FAILED;
    }
  }, {
    key: "isLoading",

    /**
     * is loading
     * @return {boolean}
     */
    get: function get() {
      return this.API_STATE === _constants.API_STATE.LOADING;
    }
    /**
     * is fetched
     * @return {boolean}
     */

  }, {
    key: "isFetched",
    get: function get() {
      return this.API_STATE === _constants.API_STATE.SUCCESS;
    }
    /**
     * has error
     * @return {boolean}
     */

  }, {
    key: "hasError",
    get: function get() {
      return this.API_STATE === _constants.API_STATE.FAILED;
    }
    /**
     * countries
     * @returns {Array<Object>}
     */

  }, {
    key: "countries",
    get: function get() {
      return this.data.map(_countries.formatCountry);
    }
    /**
     * filters
     * @returns {{currencies: Array, languages: Array, regions: Array}}
     */

  }, {
    key: "filters",
    get: function get() {
      return (0, _generateFilters.generateFiltersData)(this.countries);
    }
  }]);
  return CountriesStore;
}(), _temp), (_descriptor = (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "data", [_dec], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor2 = (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "API_STATE", [_mobx.observable], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return _constants.API_STATE.INITIAL;
  }
}), (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "isLoading", [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, "isLoading"), _class.prototype), (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "isFetched", [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, "isFetched"), _class.prototype), (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "hasError", [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, "hasError"), _class.prototype), (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "countries", [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, "countries"), _class.prototype), (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "filters", [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, "filters"), _class.prototype), (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "updateInitialState", [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, "updateInitialState"), _class.prototype), _descriptor3 = (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "fetch", [_dec2], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return (0, _mobx.flow)(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee() {
      var errorHandler,
          res,
          _args = arguments;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              errorHandler = _args.length > 0 && _args[0] !== undefined ? _args[0] : function () {};
              _context.prev = 1;
              this.API_STATE = _constants.API_STATE.LOADING;
              _context.next = 5;
              return _countries2["default"].getAllCountries();

            case 5:
              res = _context.sent;
              this.onSuccess(res);
              _context.next = 12;
              break;

            case 9:
              _context.prev = 9;
              _context.t0 = _context["catch"](1);
              this.onError(_context.t0, errorHandler);

            case 12:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this, [[1, 9]]);
    }));
  }
}), (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "onSuccess", [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, "onSuccess"), _class.prototype), (0, _applyDecoratedDescriptor2["default"])(_class.prototype, "onError", [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, "onError"), _class.prototype)), _class));
exports["default"] = CountriesStore;
