"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var colors = require('colors');

var CountriesClient = require('./clients/countries.client')["default"];

var fs = require('fs');

var path = require('path');

function updateMocks() {
  return _updateMocks.apply(this, arguments);
}

function _updateMocks() {
  _updateMocks = (0, _asyncToGenerator2["default"])(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee() {
    var countries;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            console.log('Started fetching countries...'.cyan);
            _context.next = 3;
            return CountriesClient.getAllCountries();

          case 3:
            countries = _context.sent;
            console.log('✔ Succeeded fetching countries'.green);
            writeMockFile(path.join(process.cwd(), 'src', '__mocks__', 'countries.mock.js'), countries);

          case 6:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _updateMocks.apply(this, arguments);
}

updateMocks();
/**
 * write mock file
 * @param {string} filePath
 * @param {any} mock
 */

function writeMockFile(filePath, mock) {
  var mockData = "export default ".concat(JSON.stringify(mock));
  console.log("updating ".concat(filePath, " ...").cyan);
  fs.writeFile(filePath, mockData, function (error) {
    if (error) {
      console.error("Failed updating ".concat(filePath).red);
      console.error(error);
      process.exit(0);
    }

    console.log("\u2714 ".concat(filePath, " updated successfully").green);
  });
}