"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formatCountry = formatCountry;

/**
 * format country
 * @param {Object} country
 * @returns {{name: String, capital: String, region: String, population: String, currencies: Array<String>, languages: Array<String>}}
 */
function formatCountry() {
  var country = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return {
    name: country.name,
    capital: country.capital,
    region: country.region,
    population: country.population,
    currencies: country.currencies,
    languages: country.languages,
    code: country.alpha2Code
  };
}